g_config.construction = {
  well : {
    cost : 5,
    desirability : { base : -1,    range : 1,    step : 1 },
    employers : 0,
    pretty : "Well",
    images : {
      type_1 : { size:1, rc : "well", start : 1, count : 1 }
    },
    class : "water",
    sound : [ "well", 1 ],
  },

  reservoir : {
    cost : 80,
    desirability : { base : -6,	range : 3,	step : -2 },
    employers : 0,
    mayBurn : false,
    class : "water",
    fullOffset : [ 0, 0 ],
    images : {
      t1 : { size:3, rc : "utilitya", start : 34, count : 1 }
    },
    animation : { rc : "resvanim", start : 1, count : 29, offset : [ 0, 211 ], delay : 4 },
    sound : [ "reservoir", 1 ],
  },

  fountain : {
    cost : 15,
    desirability : { base : 0,	  range : 0,	  step : 0 },
    employers : 4,
    class : "water",
    sound : [ "fountain", 1 ]
  },

  aqueduct : {
    cost : 8,
    desirability : { base: -2, range : 2, step : 1 },
    mayBurn : false,
    class : "water",
    sound : [ "aqueduct", 1 ]
  },

  terrain : {
    class : "terrain",
    images : {
      type_1 : { size:1, rc : "land1a", start : 62, count : 1 }
    }
  },

  water : {
    class : "water",
    images : {
      type_1 : { size:1, rc : "land1a", start : 120, count : 8 }
    }
  },

  meadow : {
    class : "terrain",
    images : {
      type_1 : { size:1, rc : "land1a", start : 1, count : 1 }
    }
  },

  tree : {
    class : "tree",
    images : {
      type_1 : { size:1, rc : "land1a", start : 10, count : 7 },
      type_2 : { size:1, rc : "land1a", start : 33, count : 27 }
    }
  },

  plateau : {
    class : "rock",
    imagea : {
      type_1 : { size:1, rc : "plateau", start : 1, count : 44 }
    }
  },

  rock : {
    class : "rock",
    images : {
      type_1 : { size:1, rc : "land1a", start : 290, count : 8 },
      type_1a : { size:1, rc : "land3a", start : 71, count : 8 },
      type_2 : { size:2, rc : "land1a", start : 298, count : 4 },
      type_2a : { size:2, rc : "land3a", start : 79, count : 4 },
      type_3 : { size:3, rc : "land1a", start : 302, count : 2 },
      type_4 : { size:3, rc : "land3a", start : 83, count : 2 },
    }
  },

  road : {
    cost : 4,
    desirability : { base : 1, range : 0, step : 0 },
    class : "road",
    image : [ "land2a", 44 ],
    checkWalkersOnBuild : false,
    images : {
      type_1 : { size:1, rc : "land2a", start : 2, count : 1 }
    }
  },

  elevation : {
    cost : 0,
    class : "road",
  },

  wall : {
    desirability : 12,
    range : 0,
    class : "wall",
    cost : 10,
    inflammability : 0,
    collapsibility : 0,
  },

  fortification : {
    desirability : 16,
    range : 0,
    class : "wall",
    cost : 20,
    inflammability : 0,
    collapsibility : 0,
  },

  amphitheater : {
    cost : 100,
    desirability : { base : 4, range : 4, step : -1 },
    employers : 12,
    class : "entertainment",
    animation : { rc : "entertainment", start : 2, count : 10, offset : [ 100, 49 ], delay : 3 },
    image : [ "entertainment", 1 ],
    sound : [ "", 1 ],
  },

  theater : {
    cost : 50,
    desirability : { base : 2, range : 2, step : -1 },
    employers : 8,
    class : "entertainment",
    image : [ "entertainment", 13 ],
    animation : { rc : "entertainment", start : 14, count : 21, offset : [ 60, 36 ], delay : 3 },
    sound : [ "theatre", 1 ],
  },

  roadBlock : {
    cost : 10,
    class : "road",
    checkWalkersOnBuild : false,
    image : [ "roadBlock", 1 ],
  },

  hippodrome : {
    cost : 2500,
    desirability : { base : -3, range : 3, step : 1 },
    employers : 150,
    class : "entertainment",
  },

  colosseum : {
    cost : 500,
    desirability : { base : -3, range : 3, step : 1 },
    employers : 25,
    class : "entertainment",
    sound : [ "colloseum", 1 ],
  },

  gladiatorSchool : {
    cost : 75,
    desirability : { base : -3, range : 3, step : 1 },
    employers : 8,
    class : "entertainment",
    image : [ "glschool_a", 1 ],
    animation : { rc : "glschool_a", start : 2, count : 13, offset : [ 62, 24 ], delay : 2 },
    sound : [ "gladiatorpit", 1 ],
  },

  house : {
    cost : 10,
    desirability : { base : -3, range : 3, step : 1 },
    employers : 0,
    checkWalkersOnBuild : false,
    class : "house",
  },

  lionsNursery : {
    cost : 75,
    desirability : { base : -3, range : 3, step : 1 },
    employers : 8,
    class : "entertainment",
    image : [ "entertainment", 62 ],
    animation : { rc : "entertainment", start : 63, count : 18, offset : [ 78, 21 ], delay : 2 },
    sound : [ "lionpit", 1 ],
  },

  actorColony : {
    cost : 50,
    desirability : { base : -2, range : 3, step : 1 },
    employers : 5,
    image : [ "entertainment", 81 ],
    class : "entertainment",
    animation : { rc : "actorschoola", start : 1, count : 28, offset : [ 135, 50 ], delay : 2 },
    sound : [ "artistpit", 1  ],
  },

  chariotSchool : {
    cost : 75,
    desirability : { base : -3, range : 3, step : 1 },
    employers : 10,
    class : "entertainment",
    image : [ "entertainment", 91 ],
    animation : { rc : "entertainment", start : 92, count : 10, offset : [ 54, 23 ], delay : 2 },
    sound : [ "charioterspit", 1 ],
  },

  plaza : {
    cost : 15,
    desirability : { base : 4, range : 2,	step : -2 },
    employers : 0,
    class : "road",
    checkWalkersOnBuild : false,
    image : [ "entertainment", 102 ],
    images : {
      type_1 : { size:1, rc : "entertainment", start : 102, count : 6 },
      type_1a: { size:1, rc : "plaza", start : 3139, count : 6 },
      type_2 : { size:2, rc : "entertainment", start : 108, count : 2 },
    },
  },

  garden : {
    cost : 12,
    desirability : { base :3,	range : 3,	step : -1 },
    employers : 0,
    class : "garden",
    checkWalkersOnBuild : false,
    image : [ "entertainment", 110 ],
    images : {
      type_1 : { size:1, rc : "entertainment", start : 110, count : 4 },
      type_2 : { size:2, rc : "entertainment", start : 114, count : 3 },
    },
    sound : [ "garden", 1 ],
  },

  fort_legionaries : {
    cost : 1000,
    desirability : { base :-20,	range : 10,	step : 2 },
    employers : 16,
    class : "military",
    sound : [ "fort", 1 ],
    image : [ "fortlegioner", 1 ],
    requestDestroy : true,
    inflammability : 0,
    collapsibility : 0,
  },

  missionaryPost : {
    cost : 100,
    employers : 20,
    class : "education",
  },

  statue_small : {
    cost : 12,
    desirability : { base :3,	range : 3,	step : -1},
    employers : 0,
    class : "sight",
    sound : [ "statue", 1 ],
  },

  statue_middle : {
    cost : 60,
    desirability : { base :10,	range : 5,	step : -2 },
    employers : 0,
    class : "sight",
  },

  statue_big : {
    cost : 150,
    desirability : { base :15,	range : 5,	step : -3 },
    employers : 0,
    class : "sight",
  },

  fort_javelin : {
    cost : 1000,
    desirability : { base :-20,	range : 10,	step : 2 },
    employers : 16,
    class : "military",
    image : [ "fortspear", 1 ],
    requestDestroy : true,
    inflammability : 0,
    collapsibility : 0,
  },

  fort_horse : {
    cost : 1000,
    desirability : { base :-20,	range : 10,	step : 2 },
    employers : 16,
    class : "military",
    image : [ "fortmount", 1 ],
    requestDestroy : true,
    inflammability : 0,
    collapsibility : 0,
  },

  clinic : {
    cost : 30,
    desirability : { base :0,	range : 0,	step : 0 },
    employers : 5,
    class : "health",
    image : [ "security", 20 ],
    service : "srvc_doctor",
    patientsMax : 100,
    sound : [ "clinic", 1 ],
  },

  hospital : {
    cost : 300,
    desirability : { base :2,	range : 2,	step : -1 },
    employers : 30,
    class : "health",
    image : [ "security", 44 ],
    patientsMax : 1000,
    service : "srvc_hospital"
  },

  baths : {
    cost : 50,
    desirability : { base :4,	range : 4,	step : -1 },
    employers : 10,
    class : "health",
    image : [ "security", 32 ],
    animation : { rc : "bathanim", start : 1, count : 29, offset : [ 0, 120 ], delay : 3 },
    service : "srvc_baths",
    patientsMax : 200,
    sound : [ "baths", 1 ],
  },

  barber : {
    cost : 25,
    desirability : { base :2,	range : 2,	step : -1 },
    employers : 2,
    class : "health",
    size : [ 1, 1 ],
    patientsMax : 50,
    image : [ "barber", 1 ],
    service : "srvc_barber",
    sound : [ "barber", 1 ]
  },

  school : {
    cost : 50,
    desirability : { base :-2,	range : 2,	step : 1 },
    employers : 10,
    maxServe : 75,
    class : "education",
    image : [ "commerce", 83 ],
    sound : [ "school", 1 ],
  },

  academy : {
    cost : 100,
    desirability : { base :4,	range : 4,	step : -1 },
    employers : 30,
    maxServe : 100,
    class : "education",
    images : {
      s3 : { size: 3, rc : "academy", start : 1, count : 2 }
    },
    sound : [ "academy", 1 ]
  },

  library : {
    cost : 75,
    desirability : { base : 4,	range : 4,	step : -1 },
    employers : 20,
    maxServe : 800,
    class : "education",
    image : [ "commerce", 84 ],
    sound : [ "library", 1 ]
  },

  prefecture : {
    cost : 30,
    desirability : { base :-2,	range : 2,	step : 1 },
    employers : 6,
    images : {
      s1 : { size: 1, rc : "prefecture", start : 1, count : 4 }
    },
    animation : { rc : "prefecture_anim", start : 1, count : 9, offset : [ 10, 60 ], delay : 3 },
    class : "security",
  },

  triumphal_arch : {
    cost : 0,
    desirability : { base :18,	range : 6,	step : -3 },
    employers : 0,
    class : "sight"
  },

  gatehouse : {
    cost : 100,
    desirability : -4,
    range : 4,
    step : -1,
    employers : 3,
    class : "gate",
    inflammability : 0,
    collapsibility : 0,
  },

  tower : {
    cost : 150,
    desirability : { base :-8,	range : 4,	step : -2 },
    employers : 6,
    class : "tower",
    inflammability : 0,
    collapsibility : 0
  },

  small_ceres_temple : {
    cost : 50,
    desirability : { base :4,	range : 4,	step : -1 },
    animation : { rc : "smlceres", start : 2, count : 6, offset : [ 41, 27 ], delay : 3 },
    employers : 2,
    fires : [ [112, 5], [153, 26] ],
    class : "religion",
    image : [ "smlceres", 1 ],
    sound : [ "templeceres", 1 ],
  },

  small_neptune_temple : {
    cost : 50,
    desirability : { base :4,	range : 4,	step : -1 },
    employers : 2,
    class : "religion",
    fires : [ [93, 15], [127, 33] ],
    sound : [ "templeneptune", 1 ],
    image : [ "smlneptune", 1 ],
    animation : { rc : "smlneptune", start : 2, count : 6, offset : [ 35, 34 ], delay : 3 },
    imageOffset : [-1, -1]
  },

  small_mercury_temple : {
    cost : 50,
    desirability : { base : 4, 	range : 4,	step : -1 },
    employers : 2,
    class : "religion",
    fires : [ [42, 21], [95, -6] ],
    image : [ "smlmercury", 1 ],
    imageOffset : [-1, -1],
    animation : { rc : "smlmercury", start : 2, count : 6, offset : [ 38, 32 ], delay : 3 },
    sound : [ "templemercury", 1 ]
  },

  small_mars_temple : {
    cost : 50,
    desirability : { base : 4,	range : 4,	step : -1 },
    employers : 2,
    class : "religion",
    fires : [ [89, -1] ],
    image : [ "smlmars", 1 ],
    imageOffset : [-1, -1],
    animation : { rc : "smlmars", start : 2, count : 6, offset : [ 45, 30 ], delay : 3 },
    sound : [ "templemars", 1 ]
  },

  small_venus_temple : {
    cost : 50,
    desirability : { base : 4,	range : 4,	step : -1 },
    employers : 2,
    class : "religion",
    fires : [ [41, 34], [97, 5] ],
    image : [ "smlvenus", 1 ],
    imageOffset : [-1, -1],
    animation : { rc : "smlvenus", start : 2, count : 6, offset : [ 45, 30 ], delay : 3 },
    sound : [ "templevenus", 1 ],
  },

  big_ceres_temple : {
    cost : 150,
    desirability : { base : 8,	range : 8,	step : -1 },
    employers : 5,
    class : "religion",
    sound : [ "templeceres", 2 ],
  },

  big_neptune_temple : {
    cost : 150,
    desirability : { base : 8,	range : 8,	step : -1 },
    employers : 5,
    class : "religion",
    sound : [ "templeneptune", 2 ],
  },

  big_mercury_temple : {
    cost : 150,
    desirability : { base : 8, 	range : 8,	step : -1 },
    employers : 5,
    class : "religion",
    sound : [ "templemercury", 2 ],
  },

  big_mars_temple : {
    cost : 150,
    desirability : { base : 8, 	range : 8,	step : -1 },
    employers : 5,
    class : "religion",
    sound : [ "templemars", 2 ],
  },

  big_venus_temple : {
    cost : 150,
    desirability : { base : 8, 	range : 8,	step : -1 },
    employers : 5,
    class : "religion",
    sound : [ "templevenus", 2 ],
  },

  market : {
    cost : 40,
    desirability : { base : -2, range : 6, 	step : 1 },
    employers : 5,
    class : "food",
    image : [ "commerce", 1 ],
    sound : [ "market", 1 ],
    animation : { rc : "commerce", start : 2, count : 9, offset : [ 90, 45 ], delay : 4 },
  },

  granary : {
    cost : 100,
    desirability : { base : -4,	range : 4,	step : 1 },
    employers : 6,
    class : "food",
    sound : [ "granary", 1 ],
  },

  warehouse : {
    cost : 70,
    desirability : { base : -6,	range : 3,	step : 2 },
    employers : 6,
    class : "trade",
    sound : [ "warehouse", 1 ]
  },

  shipyard : {
    cost : 100,
    desirability : { base : 8,	range : 4,	step : -2 },
    employers : 10,
    class : "trade",
    sounde : [ "shipyard", 1 ]
  },

  dock : {
    cost : 100,
    desirability : { base : 8, 	range : 4,	step : -2 },
    employers : 12,
    class : "trade",

    imageNorth : {
      image : [ "transport", 5 ],
      stock : [ "transporta", 5 ],
      animation : { rc : "transport", start : 6, count : 8, delay : 6, offset : [145,145] },
    },

    imageEast : {
      image : [ "transport", 17 ],
      stock : [ "transporta", 17 ],
      animation : { rc : "transport", start : 18, count : 8, delay : 6, offset : [192, 100] },
    },

    imageSouth : {
      image : [ "transport", 29 ],
      stock : [ "transporta", 29 ],
      animation : { rc : "transport", start : 30, count : 8, delay : 6, offset : [88, 48] },
    },

    imageWest : {
      image : [ "transport", 41 ],
      stock : [ "transporta", 41 ],
      animation : { rc : "transport", start : 42, count : 8, delay : 6, offset : [34, 110] },
    },

    sound : [ "dock", 1 ],
  },

  wharf : {
    cost : 60,
    desirability : { base : 8,	range : 4, 	step : -2 },
    employers : 6,
    class : "food",
    sound : [ "wharf", 1 ],
  },

  governorHouse : {
    cost : 150,
    desirability : { base : 12, 	range : 3,	step : -2 },
    employers : 0,
    class : "administration",
  },

  governorVilla : {
    cost : 400,
    desirability : { base : 20, 	range : 4,	step : -4 },
    employers : 0,
    class : "administration",
  },

  governorPalace : {
    cost : 700,
    desirability : { base : 28, 	range : 7,	step : -4 },
    employers : 0,
    class : "administration"
  },

  engineering_post : {
    cost : 30,
    desirability : { base :-2,	range : 2,	step : 1 },
    employers : 5,
    class : "engineer",
    collapsibility : 0.5,
    animation : { rc : "engineeringa", start : 1, count : 9, offset : [ 20, 54 ], delay : 2 },
    images : {
      type_1 : { size:1, rc : "engineering", start : 1, count : 4 }
    }
  },

  low_bridge : {
    cost : 40,
    desirability : { base : 0,	range : 0,	step : 0 },
    employers : 0,
    class : "bridge",
    requestDestroy : true,
    subtileOffset : [ 0, 0 ],
  },

  high_bridge : {
    cost : 100,
    desirability : { base : 0,	range : 0,	step : 0 },
    employers : 0,
    class : "bridge",
    requestDestroy : true,
  },

  senate : {
    cost : 250,
    desirability : { base : 8,	range : 4,	step : -2 },
    employers : 20,
    class : "administration",
    sound : [ "senate", 1 ],

    ratings : {
      culture  :   { rc : "govt", index: 5, offset : [ 358, -50 ] },
      prosperity : { rc : "govt", index: 6, offset : [ 385, -37 ] },
      peace :      { rc : "govt", index: 7, offset : [ 410, -23 ] },
      favour :     { rc : "govt", index: 8, offset : [ 435, -10 ] },
    }
  },

  forum : {
    cost : 75,
    desirability : { base : 3,	range : 3,	step : -1 },
    employers : 6,
    class : "administration",
    image : [ "forum", 1 ],
    sound : [ "forum", 1 ],
  },

  native_hut : {
    cost : 50,
    desirability : { base : 0, 	range : 0,	step : 0 },
    employers : 0,
    class : "native",
  },

  native_center : {
    cost : 50,
    desirability : { base : 0,	range : 0,	step : 0 },
    employers : 0,
    class : "native",
  },

  native_field : {
    cost : 0,
    desirability : { base : 0,	range : 0,	step : 0 },
    employers : 0,
    class : "native",
  },

  military_academy : {
    cost : 1000,
    desirability : { base : -3,	range : 3,	step : 1 },
    employers : 20,
    sound : [ "military_acad", 1 ],
    class : "military",
  },

  barracks : {
    cost : 150,
    desirability : { base : -6,	range : 3,	step : 2 },
    employers : 10,
    class : "military",
    sound : [ "barracks", 1 ],
  },

  oracle : {
    cost : 20,
    desirability : { base : 8,	range : 7,	step : -1 },
    employers : 6,
    image : [ "security", 55 ],
    class : "religion",
  },

  burning_ruins : {
    cost : 0,
    desirability : { base : -2,	range : 2,	step : 1 },
    employers : 0,
    class : "disaster",
    sound : [ "burningruins", 1 ],
  },

  burned_ruins : {
    cost : 0,
    desirability : { base : -2,	range : 2,	step : 1 },
    employers : 0,
    class : "disaster",
  },

  collapsed_ruins : {
    cost : 0,
    desirability : { base : -2,	range : 2,	step : 1 },
    employers : 0,
    class : "disaster",
  },

  plague_ruins :
  {
    cost : 0,
    desirability : { base : -2,	range : 2,	step : 1 },
    employers : 0,
    class : "disaster",
  },

  farmtile :
  {
    cost : 0,
    desirability : { base : 0, range : 0,	step : 0 },
    class : "food",
  },

  wheat_farm :
  {
    cost : 40,
    undoOffset : [ 0, -1 ],
    desirability : { base : -2,	range : 2,	step : 1 },
    employers : 10,
    class : "food",
    output : "wheat",
    productRate : 9.6,
    sound : [ "wheatfarm", 1 ],
  },

  vegetable_farm :
  {
    cost : 40,
    undoOffset : [ 0, -1 ],
    desirability : { base : -2, 	range : 2,	step : 1 },
    employers : 10,
    productRate : 9.6,
    class : "food",
    output : "vegetable",
    sound : [ "vegetablefarm", 1 ],
    image : [ "vegfarm", 1 ],
  },

  fig_farm :
  {
    cost : 40,
    undoOffset : [ 0, -1 ],
    desirability : { base : -2,	range : 2,	step : 1 },
    employers : 10,
    output : "fruit",
    productRate : 9.6,
    class : "food",
    sound : [ "fig_farm", 1 ],
    image : [ "fruitfarm", 1 ],
  },

  olive_farm :
  {
    cost : 40,
    undoOffset : [ 0, -1 ],
    desirability : { base : -2,	range : 2,	step : 1 },
    employers : 10,
    class : "food",
    output : "olive",
    productRate : 9.6,
    sound : [ "olivesfarm", 1 ],
    image : [ "olivefarm", 1 ],
  },

  vinard :
  {
    cost : 40,
    undoOffset : [ 0, -1 ],
    desirability : { base : -2,	range : 2,	step : 1 },
    employers : 10,
    class : "food",
    output : "grape",
    productRate : 4.8,
    sound : [ "grapefarm", 1 ],
    image : [ "wineyard", 1 ],
  },

  meat_farm :
  {
    cost : 40,
    undoOffset : [ 0, -1 ],
    desirability : { base : -2,	range : 2,	step : 1 },
    employers : 10,
    class : "food",
    output : "meat",
    productRate : 4.8,
    image : [ "meatfarm", 1 ],
    sound : [ "meatfarm", 1 ],
  },

  quarry :
  {
    cost : 50,
    desirability : { base : -6,	range : 6,	step : 1 },
    employers : 10,
    class : "rawmaterial",
    output : "marble",
    productRate : 2.4,
    sound : [ "marblequarry", 1 ],
    image : [ "quarry", 1 ],
    animation : { rc : "quarryanim", start : 1, count : 11, offset : [ 105, 30 ], delay : 3 },
    collapsibility : 1.5,
  },

  iron_mine :
  {
    cost : 50,
    desirability : { base : -6,	range : 6,	step : 1 },
    employers : 10,
    output : "iron",
    class : "rawmaterial",
    productRate : 2.4,
    image : [ "commerce", 54 ],
    animation : { rc : "ironminea", start : 1, count : 34, offset : [ 75, 30 ], delay : 3 },
    sound : [ "ironmine", 1 ],
    collapsibility : 1.4,
  },

  lumber_mill :
  {
    cost : 40,
    desirability : { base : -4,	range : 4,	step : 1 },
    employers : 10,
    output : "timber",
    class : "rawmaterial",
    productRate : 4.8,
    image : [ "lumbermill", 1 ],
    animation : { rc : "lmbmill_anim", start : 1, count : 12, offset : [ 80, 2 ], delay : 3 },
    sound : [ "lumbermill", 1 ],
    inflammability : 1.3,
  },

  clay_pit :
  {
    cost : 40,
    desirability : { base : -3,	range : 3,	step : 1 },
    employers : 10,
    image : [ "commerce", 61 ],
    productRate : 4.8,
    output : "clay",
    class : "rawmaterial",
    animation : { rc : "commerce", start : 62, count : 10, offset : [ 0, 60 ], delay : 3 },
    sound : [ "claypit", 1 ],
    collapsibility : 1.3,
  },

  wine_workshop :
  {
    cost : 45,
    desirability : { base : -1,	range : 1,	step : 1 },
    employers : 10,
    productRate : 4.8,
    output : "wine",
    class : "industry",
    sound : [ "winery", 1 ],
    inflammability : 0.7,
    image : [ "commerce", 86 ],
    animation : { rc : "commerce", start : 87, count : 12, offset : [ 140, 36 ], delay : 4 },
    stockImage : {
      qty_100 : { qty : 100, image : [ "vinardst", 1 ], offset : [0,27] },
      qty_200 : { qty : 200, image : [ "vinardst", 2 ], offset : [0,27] },
      qty_300 : { qty : 300, image : [ "vinardst", 3 ], offset : [0,27] },
    }
  },

  oil_workshop :
  {
    cost : 50,
    desirability : { base : -4,	range : 2,	step : 2 },
    employers : 10,
    output : "oil",
    class : "industry",
    productRate : 4.8,
    sound : [ "creamery", 1 ],
    image : [ "oilworkshop", 1 ],
    animation : { rc : "oilworkshopa", start : 1, count : 8, offset : [ 78, 25 ], delay : 4 },
    stockImage : {
      qty_100 : { qty : 100, image : [ "oilworkshops", 1 ], offset : [0,27] },
      qty_200 : { qty : 200, image : [ "oilworkshops", 2 ], offset : [0,27] },
      qty_300 : { qty : 300, image : [ "oilworkshops", 3 ], offset : [0,27] },
    },
    inflammability : 1.2
  },

  weapons_workshop :
  {
    cost : 50,
    desirability : { base : -4,	range : 2,	step : 2 },
    employers : 10,
    productRate : 2.4,
    output : "weapon",
    class : "industry",
    sound : [ "weapons_workshop", 1 ],
    image : [ "commerce", 108 ],
    inflammability : 2,
    animation : { rc : "commerce", start : 109, count : 8, offset : [ 60, 127 ], delay : 4 },
    stockImage : {
      qty_100 : { qty : 100, image : [ "weaponst", 1 ], offset : [0,27] },
      qty_200 : { qty : 200, image : [ "weaponst", 2 ], offset : [0,27] },
      qty_300 : { qty : 300, image : [ "weaponst", 3 ], offset : [0,27] },
    }
  },

  furniture_workshop :
  {
    cost : 40,
    desirability : { base : -4,	range : 2,	step : 2 },
    employers : 10,
    class : "industry",
    productRate : 2.4,
    output : "furniture",
    sound : [ "furniture", 1 ],
    image : [ "commerce", 118 ],
    inflammability : 1.3,
    animation : { rc : "commerce", start : 119, count : 11, offset : [ 112, -11 ], delay : 3 },
    stockImage : {
      qty_100 : { qty : 100, image : [ "furniturest", 1 ], offset : [0,27] },
      qty_200 : { qty : 200, image : [ "furniturest", 2 ], offset : [0,27] },
      qty_300 : { qty : 300, image : [ "furniturest", 3 ], offset : [0,27] },
    }
  },

  pottery_workshop :
  {
    cost : 40,
    desirability : { base : -4,	range : 2,	step : 2 },
    employers : 10,
    output : "pottery",
    class : "industry",
    productRate : 4.8,
    inflammability : 1.4,
    image : [ "commerce", 132 ],
    animation : { rc : "commerce", start : 133, count : 7, offset : [ 168, 137 ], delay : 3 },
    stockImage : {
      qty_100 : { qty : 100, image : [ "potteryst", 1 ], offset : [0,27] },
      qty_200 : { qty : 200, image : [ "potteryst", 2 ], offset : [0,27] },
      qty_300 : { qty : 300, image : [ "potteryst", 3 ], offset : [0,27] },
    }
  }
}
